<template>
  <v-data-table
    :headers="headers"
    :items="products"
    hide-default-footer
    disable-pagination
  >
    <template #item.detailsId="{ item }">
      {{ hashId(item) }}
    </template>
    <template #item.quantity="{ item }">
      {{ countItems(item) }}
    </template>
  </v-data-table>
</template>

<script>
import { mapState } from 'vuex';
import { countBy, prop } from 'ramda';
import { hashId } from '~/helpers/format/ids';

export default {
  name: 'PalletsTable',
  data: () => ({
    headers: [
      {
        text: 'Nª',
        align: 'start',
        value: 'detailsId',
      },
      {
        text: 'Producto',
        value: 'description',
      },
      {
        text: 'Unidades (pallets)',
        value: 'quantity',
      },
    ],
  }),
  computed: {
    ...mapState({
      products: state => state.storage.areas.current.products,
      items: state => state.storage.areas.current.items,
    }),
    itemsPerProduct() {
      return countBy(prop('productDetailId'), this.items);
    },
  },
  methods: {
    hashId,
    countItems({ detailsId }) {
      return prop(detailsId, this.itemsPerProduct);
    },
  },
};
</script>
